local RayUI, E, _, V, P, G = unpack(select(2, ...))
local RTT = RayUI:NewModule('RayUITooltip', 'AceHook-3.0', 'AceEvent-3.0', 'AceTimer-3.0')
local TT = E.Tooltip

--Cache global variables
--Lua functions
--WoW API / Variables
local _G, hooksecurefunc, string = _G, hooksecurefunc, string
local UnitIsPlayer = UnitIsPlayer

-- GLOBALS:

function RTT:SetUnitText(tt, unit, level, isShiftKeyDown)
	if not UnitIsPlayer(unit) then
		if tt:IsForbidden() then return end
		for i=2, tt:NumLines() do
			local leftLine = _G["GameTooltipTextLeft"..i]
			local leftText = leftLine and leftLine.GetText and leftLine:GetText()
			if leftText then
				leftLine:SetText(leftText:gsub("%|cff7f7f7f%?%?%|r", "|cffff1919??|r"))
			end
		end
	end
end

function RTT:GameTooltip_OnTooltipSetUnit(tt)
	if tt:IsForbidden() then return end
	for i=2, tt:NumLines() do
		local leftLine = _G["GameTooltipTextLeft"..i]
		local rightLine = _G["GameTooltipTextRight"..i]
		local leftText = leftLine and leftLine.GetText and leftLine:GetText()
		local rightText = rightLine and rightLine.GetText and rightLine:GetText()
		if leftText and leftText:find(_G.TARGET) and rightText and rightText:find(E.myname) then
			rightLine:SetText(string.format("|cffff0000>> %s <<|r", _G.YOU))
		end
	end
end

function RTT:Initialize()
	if E.private.tooltip.enable ~= true then return end

	hooksecurefunc(TT, "SetUnitText", RTT.SetUnitText)
	hooksecurefunc(TT, "GameTooltip_OnTooltipSetUnit", RTT.GameTooltip_OnTooltipSetUnit)
end

RayUI:RegisterModule(RTT:GetName())
